Codeforces 366C Dima and Salad【01背包】好题

22 篇文章 1 订阅

C. Dima and Salad
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Dima, Inna and Seryozha have gathered in a room. That's right, someone's got to go. To cheer Seryozha up and inspire him to have a walk, Inna decided to cook something.

Dima and Seryozha have n fruits in the fridge. Each fruit has two parameters: the taste and the number of calories. Inna decided to make a fruit salad, so she wants to take some fruits from the fridge for it. Inna follows a certain principle as she chooses the fruits: the total taste to the total calories ratio of the chosen fruits must equal k. In other words, , where aj is the taste of the j-th chosen fruit and bj is its calories.

Inna hasn't chosen the fruits yet, she is thinking: what is the maximum taste of the chosen fruits if she strictly follows her principle? Help Inna solve this culinary problem — now the happiness of a young couple is in your hands!

Inna loves Dima very much so she wants to make the salad from at least one fruit.

Input

The first line of the input contains two integers n, k (1 ≤ n ≤ 100, 1 ≤ k ≤ 10). The second line of the input contains n integers a1, a2, ..., an (1 ≤ ai ≤ 100) — the fruits' tastes. The third line of the input contains n integers b1, b2, ..., bn (1 ≤ bi ≤ 100) — the fruits' calories. Fruit number i has taste ai and calories bi.

Output

If there is no way Inna can choose the fruits for the salad, print in the single line number -1. Otherwise, print a single integer — the maximum possible sum of the taste values of the chosen fruits.

Examples
Input
3 2
10 8 1
2 7 1
Output
18
Input
5 3
4 4 4 4 4
2 2 2 2 2
Output
-1
Note

In the first test sample we can get the total taste of the fruits equal to 18 if we choose fruit number 1 and fruit number 2, then the total calories will equal 9. The condition fulfills, that's exactly what Inna wants.

In the second test sample we cannot choose the fruits so as to follow Inna's principle.


题目大意:

给你N组数对,问怎样拿能够使得:Σa【i】/Σb【i】==k,并且使Σa【i】尽量大,输出这个最大的Σa【i】;


思路:


1、拿取的方案有很多,显然暴力直接写是不行的,考虑背包问题,每个数对如果想要拿 ,那么拿且只能拿一次,那么此时满足01背包的条件。


2、我们要使得Σa【i】的值尽量大 ,那么我们明显需要将a【i】作为物品的价值。此时考虑以a【i】-k*b【i】作为花费。那么我们只要保证最终的花费为0,那么就能够保证Σa【i】=k*Σb【i】;


3、考虑到差值可能为负,那么我们将差值为正的做一次背包,差值为负的变成正之后再做一次背包,那么此时dp【i】+dp2【i】其实就是表示最终花费为0.那么我们dp之后,维护最大值即可。


Ac 代码:

#include<stdio.h>
#include<string.h>
#include<iostream>
using namespace std;
struct node
{
    int val,cost;
}a[1500];
int dp[100*150];
int dp2[100*150];
int main()
{
    int n,k;
    while(~scanf("%d%d",&n,&k))
    {
        for(int i=0;i<n;i++)
        {
            scanf("%d",&a[i].val);
        }
        for(int i=0;i<n;i++)
        {
            int x;
            scanf("%d",&x);
            a[i].cost=a[i].val-k*x;
        }
        memset(dp,-0x3f3f3f3f,sizeof(dp));
        memset(dp2,-0x3f3f3f3f,sizeof(dp2));
        dp[0]=0;dp2[0]=0;
        for(int i=0;i<n;i++)
        {
            if(a[i].cost>=0)
            {
                for(int j=100*105;j>=a[i].cost;j--)
                {
                    dp[j]=max(dp[j],dp[j-a[i].cost]+a[i].val);
                }
            }
            else
            {
                a[i].cost=-a[i].cost;
                for(int j=100*105;j>=a[i].cost;j--)
                {
                    dp2[j]=max(dp2[j],dp2[j-a[i].cost]+a[i].val);
                }
            }
        }
        int ans=-1;
        for(int i=0;i<=100*105;i++)
        {
            if(dp[i]+dp2[i]==0)continue;
            if(dp[i]+dp2[i]>ans)ans=dp[i]+dp2[i];
        }
        printf("%d\n",ans);
    }
}




  • 2
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值